package com.fp.persistence.parmas.fun;

import javax.persistence.Column;

import java.io.Serializable;

import com.fp.dto.hb.HibernateId;

import java.lang.reflect.Field;

import javax.persistence.Embeddable;
import javax.persistence.GeneratedValue;
import javax.persistence.Transient;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

/**Clase que hace referencia a la Clave Primaria de TARMSOLICITUDIMPORTACION*/
@Embeddable
public class TarmSolicitudImportacionKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="CIMPORTACION", nullable=false,updatable=false)
/**
* null
*/
private Long cimportacion;

@Column(name="CSOLICITUD", nullable=false,updatable=false)

/**
* Codigo de solicitud de controld e armas
*/
private String csolicitud;

/**Contructor por defecto*/
public TarmSolicitudImportacionKey(){}
/**Contructor de TarmSolicitudImportacionKey
@param pCimportacion null
@param pCsolicitud Codigo de solicitud de controld e armas
*/
public TarmSolicitudImportacionKey(Long pCimportacion,String pCsolicitud){
 cimportacion=pCimportacion;
 csolicitud=pCsolicitud;
}
/**Obtiene el valor de cimportacion
@return valor de cimportacion*/
public Long getCimportacion(){
  return cimportacion;
}
/**Fija el valor de cimportacion
@param pCimportacion nuevo Valor de cimportacion*/
public void setCimportacion(Long pCimportacion){
  cimportacion=pCimportacion;
}

/**Obtiene el valor de csolicitud
@return valor de csolicitud*/
public String getCsolicitud(){
  return csolicitud;
}
/**Fija el valor de csolicitud
@param pCsolicitud nuevo Valor de csolicitud*/
public void setCsolicitud(String pCsolicitud){
  csolicitud=pCsolicitud;
}

/**Implementacion de la comparacion de TarmSolicitudImportacionKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TarmSolicitudImportacionKey))return false;
  TarmSolicitudImportacionKey that = (TarmSolicitudImportacionKey) o;
  if (this.getCimportacion() == null || that.getCimportacion() == null){
      return false;
  }
  if (! this.getCimportacion().equals(that.getCimportacion())){
    return false;
  }
  if (this.getCsolicitud() == null || that.getCsolicitud() == null){
      return false;
  }
  if (! this.getCsolicitud().equals(that.getCsolicitud())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TarmSolicitudImportacionKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getCimportacion() == null ? 0 : this.getCimportacion().hashCode());
    result = result * 37 + (this.getCsolicitud() == null ? 0 : this.getCsolicitud().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
